"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.audittrails.v1.trail_pb2
import yandex.cloud.audittrails.v1.trail_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class TrailServiceStub:
    """A set of methods for managing trails."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.GetTrailRequest,
        yandex.cloud.audittrails.v1.trail_pb2.Trail,
    ]
    """Returns the specified trail.

    To get the list of all available trails, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsRequest,
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsResponse,
    ]
    """Retrieves the list of trails in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.CreateTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a trail in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.UpdateTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified trail."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.DeleteTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified trail."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsRequest,
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsResponse,
    ]
    """Lists operations for the specified trail."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified trail."""

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the trail."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the trail."""

class TrailServiceAsyncStub:
    """A set of methods for managing trails."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.GetTrailRequest,
        yandex.cloud.audittrails.v1.trail_pb2.Trail,
    ]
    """Returns the specified trail.

    To get the list of all available trails, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsRequest,
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsResponse,
    ]
    """Retrieves the list of trails in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.CreateTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a trail in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.UpdateTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified trail."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.DeleteTrailRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified trail."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsRequest,
        yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsResponse,
    ]
    """Lists operations for the specified trail."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified trail."""

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the trail."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the trail."""

class TrailServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing trails."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.GetTrailRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.audittrails.v1.trail_pb2.Trail, collections.abc.Awaitable[yandex.cloud.audittrails.v1.trail_pb2.Trail]]:
        """Returns the specified trail.

        To get the list of all available trails, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsResponse, collections.abc.Awaitable[yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailsResponse]]:
        """Retrieves the list of trails in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.CreateTrailRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a trail in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.UpdateTrailRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified trail."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.DeleteTrailRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified trail."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsResponse, collections.abc.Awaitable[yandex.cloud.audittrails.v1.trail_service_pb2.ListTrailOperationsResponse]]:
        """Lists operations for the specified trail."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """Lists existing access bindings for the specified trail."""

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the trail."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the trail."""

def add_TrailServiceServicer_to_server(servicer: TrailServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
