"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.certificatemanager.v1.certificate_pb2
import yandex.cloud.certificatemanager.v1.certificate_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class CertificateServiceStub:
    """A set of methods for managing certificates."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.GetCertificateRequest,
        yandex.cloud.certificatemanager.v1.certificate_pb2.Certificate,
    ]
    """Returns the specified certificate.

    To get the list of available certificates, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesResponse,
    ]
    """Returns the list of certificates in the specified folder."""

    ListVersions: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsResponse,
    ]

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.CreateCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a certificate in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.UpdateCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified certificate."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.DeleteCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified certificate."""

    RequestNew: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.RequestNewCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Request a certificate in the specified folder."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsResponse,
    ]
    """Lists operations for the specified certificate."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified certificate."""

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the certificate."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified certificate."""

class CertificateServiceAsyncStub:
    """A set of methods for managing certificates."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.GetCertificateRequest,
        yandex.cloud.certificatemanager.v1.certificate_pb2.Certificate,
    ]
    """Returns the specified certificate.

    To get the list of available certificates, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesResponse,
    ]
    """Returns the list of certificates in the specified folder."""

    ListVersions: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsResponse,
    ]

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.CreateCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a certificate in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.UpdateCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified certificate."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.DeleteCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified certificate."""

    RequestNew: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.RequestNewCertificateRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Request a certificate in the specified folder."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsRequest,
        yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsResponse,
    ]
    """Lists operations for the specified certificate."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified certificate."""

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the certificate."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified certificate."""

class CertificateServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing certificates."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.GetCertificateRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.certificatemanager.v1.certificate_pb2.Certificate, collections.abc.Awaitable[yandex.cloud.certificatemanager.v1.certificate_pb2.Certificate]]:
        """Returns the specified certificate.

        To get the list of available certificates, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesResponse, collections.abc.Awaitable[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificatesResponse]]:
        """Returns the list of certificates in the specified folder."""

    @abc.abstractmethod
    def ListVersions(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsResponse, collections.abc.Awaitable[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListVersionsResponse]]: ...

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.CreateCertificateRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a certificate in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.UpdateCertificateRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified certificate."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.DeleteCertificateRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified certificate."""

    @abc.abstractmethod
    def RequestNew(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.RequestNewCertificateRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Request a certificate in the specified folder."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsResponse, collections.abc.Awaitable[yandex.cloud.certificatemanager.v1.certificate_service_pb2.ListCertificateOperationsResponse]]:
        """Lists operations for the specified certificate."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """Lists existing access bindings for the specified certificate."""

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the certificate."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the specified certificate."""

def add_CertificateServiceServicer_to_server(servicer: CertificateServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
