"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.compute.v1.filesystem_pb2
import yandex.cloud.compute.v1.filesystem_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class FilesystemServiceStub:
    """A set of methods for managing filesystems."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.GetFilesystemRequest,
        yandex.cloud.compute.v1.filesystem_pb2.Filesystem,
    ]
    """Returns the specified filesystem.

    To get the list of available filesystems, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsRequest,
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsResponse,
    ]
    """Lists filesystems in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.CreateFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a filesystem in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.UpdateFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified filesystem."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.DeleteFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified filesystem.

    Deleting a filesystem removes its data permanently and is irreversible.

    It is not possible to delete a filesystem that is attached to an instance.
    """

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsRequest,
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsResponse,
    ]
    """Lists operations for the specified filesystem."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the filesystem.
    """

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the filesystem."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the filesystem."""

class FilesystemServiceAsyncStub:
    """A set of methods for managing filesystems."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.GetFilesystemRequest,
        yandex.cloud.compute.v1.filesystem_pb2.Filesystem,
    ]
    """Returns the specified filesystem.

    To get the list of available filesystems, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsRequest,
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsResponse,
    ]
    """Lists filesystems in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.CreateFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a filesystem in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.UpdateFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified filesystem."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.DeleteFilesystemRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified filesystem.

    Deleting a filesystem removes its data permanently and is irreversible.

    It is not possible to delete a filesystem that is attached to an instance.
    """

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsRequest,
        yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsResponse,
    ]
    """Lists operations for the specified filesystem."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the filesystem.
    """

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the filesystem."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the filesystem."""

class FilesystemServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing filesystems."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.GetFilesystemRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.filesystem_pb2.Filesystem, collections.abc.Awaitable[yandex.cloud.compute.v1.filesystem_pb2.Filesystem]]:
        """Returns the specified filesystem.

        To get the list of available filesystems, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsResponse, collections.abc.Awaitable[yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemsResponse]]:
        """Lists filesystems in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.CreateFilesystemRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a filesystem in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.UpdateFilesystemRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified filesystem."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.DeleteFilesystemRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified filesystem.

        Deleting a filesystem removes its data permanently and is irreversible.

        It is not possible to delete a filesystem that is attached to an instance.
        """

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsResponse, collections.abc.Awaitable[yandex.cloud.compute.v1.filesystem_service_pb2.ListFilesystemOperationsResponse]]:
        """Lists operations for the specified filesystem."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """access

        Lists access bindings for the filesystem.
        """

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the filesystem."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the filesystem."""

def add_FilesystemServiceServicer_to_server(servicer: FilesystemServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
