"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.compute.v1.placement_group_pb2
import yandex.cloud.compute.v1.placement_group_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class PlacementGroupServiceStub:
    """A set of methods for managing placement groups."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.GetPlacementGroupRequest,
        yandex.cloud.compute.v1.placement_group_pb2.PlacementGroup,
    ]
    """Returns the specified placement group.

    To get the list of all available placement groups, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsResponse,
    ]
    """Retrieves the list of placement groups in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.CreatePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a placement group in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.UpdatePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified placement group."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.DeletePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified placement group."""

    ListInstances: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesResponse,
    ]
    """Lists instances for the specified placement group."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsResponse,
    ]
    """Lists operations for the specified placement group."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the placement group.
    """

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the placement group."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the placement group."""

class PlacementGroupServiceAsyncStub:
    """A set of methods for managing placement groups."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.GetPlacementGroupRequest,
        yandex.cloud.compute.v1.placement_group_pb2.PlacementGroup,
    ]
    """Returns the specified placement group.

    To get the list of all available placement groups, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsResponse,
    ]
    """Retrieves the list of placement groups in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.CreatePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a placement group in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.UpdatePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified placement group."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.DeletePlacementGroupRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified placement group."""

    ListInstances: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesResponse,
    ]
    """Lists instances for the specified placement group."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsRequest,
        yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsResponse,
    ]
    """Lists operations for the specified placement group."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the placement group.
    """

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the placement group."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the placement group."""

class PlacementGroupServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing placement groups."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.GetPlacementGroupRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.placement_group_pb2.PlacementGroup, collections.abc.Awaitable[yandex.cloud.compute.v1.placement_group_pb2.PlacementGroup]]:
        """Returns the specified placement group.

        To get the list of all available placement groups, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsResponse, collections.abc.Awaitable[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupsResponse]]:
        """Retrieves the list of placement groups in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.CreatePlacementGroupRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a placement group in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.UpdatePlacementGroupRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified placement group."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.DeletePlacementGroupRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified placement group."""

    @abc.abstractmethod
    def ListInstances(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesResponse, collections.abc.Awaitable[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupInstancesResponse]]:
        """Lists instances for the specified placement group."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsResponse, collections.abc.Awaitable[yandex.cloud.compute.v1.placement_group_service_pb2.ListPlacementGroupOperationsResponse]]:
        """Lists operations for the specified placement group."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """access

        Lists access bindings for the placement group.
        """

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the placement group."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the placement group."""

def add_PlacementGroupServiceServicer_to_server(servicer: PlacementGroupServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
