"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.k8s.v1.cluster_pb2
import yandex.cloud.k8s.v1.cluster_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class ClusterServiceStub:
    """A set of methods for managing Kubernetes cluster."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.GetClusterRequest,
        yandex.cloud.k8s.v1.cluster_pb2.Cluster,
    ]
    """Returns the specified Kubernetes cluster.

    To get the list of available Kubernetes cluster, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersResponse,
    ]
    """Retrieves the list of Kubernetes cluster in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.CreateClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a Kubernetes cluster in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.UpdateClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified Kubernetes cluster."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.DeleteClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified Kubernetes cluster."""

    Stop: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.StopClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Stops the specified Kubernetes cluster."""

    Start: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.StartClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Starts the specified Kubernetes cluster."""

    RescheduleMaintenance: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.RescheduleMaintenanceRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Reschedules mandatory maintenance for the specified cluster."""

    ListNodeGroups: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsResponse,
    ]
    """Lists nodegroup for the specified Kubernetes cluster."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsResponse,
    ]
    """Lists operations for the specified Kubernetes cluster."""

    ListNodes: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesResponse,
    ]
    """Lists cluster's nodes."""

class ClusterServiceAsyncStub:
    """A set of methods for managing Kubernetes cluster."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.GetClusterRequest,
        yandex.cloud.k8s.v1.cluster_pb2.Cluster,
    ]
    """Returns the specified Kubernetes cluster.

    To get the list of available Kubernetes cluster, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersResponse,
    ]
    """Retrieves the list of Kubernetes cluster in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.CreateClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a Kubernetes cluster in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.UpdateClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified Kubernetes cluster."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.DeleteClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified Kubernetes cluster."""

    Stop: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.StopClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Stops the specified Kubernetes cluster."""

    Start: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.StartClusterRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Starts the specified Kubernetes cluster."""

    RescheduleMaintenance: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.RescheduleMaintenanceRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Reschedules mandatory maintenance for the specified cluster."""

    ListNodeGroups: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsResponse,
    ]
    """Lists nodegroup for the specified Kubernetes cluster."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsResponse,
    ]
    """Lists operations for the specified Kubernetes cluster."""

    ListNodes: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesRequest,
        yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesResponse,
    ]
    """Lists cluster's nodes."""

class ClusterServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing Kubernetes cluster."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.GetClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.k8s.v1.cluster_pb2.Cluster, collections.abc.Awaitable[yandex.cloud.k8s.v1.cluster_pb2.Cluster]]:
        """Returns the specified Kubernetes cluster.

        To get the list of available Kubernetes cluster, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersResponse, collections.abc.Awaitable[yandex.cloud.k8s.v1.cluster_service_pb2.ListClustersResponse]]:
        """Retrieves the list of Kubernetes cluster in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.CreateClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a Kubernetes cluster in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.UpdateClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified Kubernetes cluster."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.DeleteClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified Kubernetes cluster."""

    @abc.abstractmethod
    def Stop(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.StopClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Stops the specified Kubernetes cluster."""

    @abc.abstractmethod
    def Start(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.StartClusterRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Starts the specified Kubernetes cluster."""

    @abc.abstractmethod
    def RescheduleMaintenance(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.RescheduleMaintenanceRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Reschedules mandatory maintenance for the specified cluster."""

    @abc.abstractmethod
    def ListNodeGroups(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsResponse, collections.abc.Awaitable[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodeGroupsResponse]]:
        """Lists nodegroup for the specified Kubernetes cluster."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsResponse, collections.abc.Awaitable[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterOperationsResponse]]:
        """Lists operations for the specified Kubernetes cluster."""

    @abc.abstractmethod
    def ListNodes(
        self,
        request: yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesResponse, collections.abc.Awaitable[yandex.cloud.k8s.v1.cluster_service_pb2.ListClusterNodesResponse]]:
        """Lists cluster's nodes."""

def add_ClusterServiceServicer_to_server(servicer: ClusterServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
