"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.marketplace.licensemanager.v1.lock_pb2
import yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class LockServiceStub:
    """A set of methods for managing subscription locks."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock,
    ]
    """Returns the specified subscription lock."""

    GetByInstanceAndResource: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockByInstanceAndResourceRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock,
    ]
    """Returns the subscription lock for specified subscription instance and resource."""

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksResponse,
    ]
    """Returns subscriptions locks for specified resource and folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.CreateLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Locks the specified subscription instance to the resource."""

    Ensure: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.EnsureLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Checks if the she specified subscription is already locked to the specified resource.
    If it is not locked, locks the subscription to the resource.
    """

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.DeleteLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Unlocks the specified subscription lock."""

class LockServiceAsyncStub:
    """A set of methods for managing subscription locks."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock,
    ]
    """Returns the specified subscription lock."""

    GetByInstanceAndResource: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockByInstanceAndResourceRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock,
    ]
    """Returns the subscription lock for specified subscription instance and resource."""

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksRequest,
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksResponse,
    ]
    """Returns subscriptions locks for specified resource and folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.CreateLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Locks the specified subscription instance to the resource."""

    Ensure: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.EnsureLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Checks if the she specified subscription is already locked to the specified resource.
    If it is not locked, locks the subscription to the resource.
    """

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.DeleteLockRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Unlocks the specified subscription lock."""

class LockServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing subscription locks."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock, collections.abc.Awaitable[yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock]]:
        """Returns the specified subscription lock."""

    @abc.abstractmethod
    def GetByInstanceAndResource(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.GetLockByInstanceAndResourceRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock, collections.abc.Awaitable[yandex.cloud.marketplace.licensemanager.v1.lock_pb2.Lock]]:
        """Returns the subscription lock for specified subscription instance and resource."""

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksResponse, collections.abc.Awaitable[yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.ListLocksResponse]]:
        """Returns subscriptions locks for specified resource and folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.CreateLockRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Locks the specified subscription instance to the resource."""

    @abc.abstractmethod
    def Ensure(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.EnsureLockRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Checks if the she specified subscription is already locked to the specified resource.
        If it is not locked, locks the subscription to the resource.
        """

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.marketplace.licensemanager.v1.lock_service_pb2.DeleteLockRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Unlocks the specified subscription lock."""

def add_LockServiceServicer_to_server(servicer: LockServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
