"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.mdb.clickhouse.v1.ml_model_pb2
import yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2
import yandex.cloud.operation.operation_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class MlModelServiceStub:
    """A set of methods for managing machine learning models."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.GetMlModelRequest,
        yandex.cloud.mdb.clickhouse.v1.ml_model_pb2.MlModel,
    ]
    """Returns the specified machine learning model.

    To get the list of all available models, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsRequest,
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsResponse,
    ]
    """Retrieves the list of machine learning models in the specified cluster."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.CreateMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a machine learning model in the specified cluster."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.UpdateMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified machine learning model."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.DeleteMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified machine learning model."""

class MlModelServiceAsyncStub:
    """A set of methods for managing machine learning models."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.GetMlModelRequest,
        yandex.cloud.mdb.clickhouse.v1.ml_model_pb2.MlModel,
    ]
    """Returns the specified machine learning model.

    To get the list of all available models, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsRequest,
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsResponse,
    ]
    """Retrieves the list of machine learning models in the specified cluster."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.CreateMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a machine learning model in the specified cluster."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.UpdateMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified machine learning model."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.DeleteMlModelRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified machine learning model."""

class MlModelServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing machine learning models."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.GetMlModelRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.mdb.clickhouse.v1.ml_model_pb2.MlModel, collections.abc.Awaitable[yandex.cloud.mdb.clickhouse.v1.ml_model_pb2.MlModel]]:
        """Returns the specified machine learning model.

        To get the list of all available models, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsResponse, collections.abc.Awaitable[yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.ListMlModelsResponse]]:
        """Retrieves the list of machine learning models in the specified cluster."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.CreateMlModelRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a machine learning model in the specified cluster."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.UpdateMlModelRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified machine learning model."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.mdb.clickhouse.v1.ml_model_service_pb2.DeleteMlModelRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified machine learning model."""

def add_MlModelServiceServicer_to_server(servicer: MlModelServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
