"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import builtins
import google.protobuf.descriptor
import google.protobuf.internal.enum_type_wrapper
import google.protobuf.message
import google.protobuf.timestamp_pb2
import sys
import typing

if sys.version_info >= (3, 10):
    import typing as typing_extensions
else:
    import typing_extensions

DESCRIPTOR: google.protobuf.descriptor.FileDescriptor

@typing.final
class Backup(google.protobuf.message.Message):
    """A PostgreSQL Backup resource. For more information, see
    the [Developer's Guide](/docs/managed-postgresql/concepts/backup).
    """

    DESCRIPTOR: google.protobuf.descriptor.Descriptor

    class _BackupMethod:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _BackupMethodEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Backup._BackupMethod.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        BACKUP_METHOD_UNSPECIFIED: Backup._BackupMethod.ValueType  # 0
        BASE: Backup._BackupMethod.ValueType  # 1
        """Base backup"""
        INCREMENTAL: Backup._BackupMethod.ValueType  # 2
        """Delta (incremental) PostgreSQL backup"""

    class BackupMethod(_BackupMethod, metaclass=_BackupMethodEnumTypeWrapper): ...
    BACKUP_METHOD_UNSPECIFIED: Backup.BackupMethod.ValueType  # 0
    BASE: Backup.BackupMethod.ValueType  # 1
    """Base backup"""
    INCREMENTAL: Backup.BackupMethod.ValueType  # 2
    """Delta (incremental) PostgreSQL backup"""

    class _BackupCreationType:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _BackupCreationTypeEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Backup._BackupCreationType.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        BACKUP_CREATION_TYPE_UNSPECIFIED: Backup._BackupCreationType.ValueType  # 0
        AUTOMATED: Backup._BackupCreationType.ValueType  # 1
        """Backup created by automated daily schedule"""
        MANUAL: Backup._BackupCreationType.ValueType  # 2
        """Backup created by user request"""

    class BackupCreationType(_BackupCreationType, metaclass=_BackupCreationTypeEnumTypeWrapper): ...
    BACKUP_CREATION_TYPE_UNSPECIFIED: Backup.BackupCreationType.ValueType  # 0
    AUTOMATED: Backup.BackupCreationType.ValueType  # 1
    """Backup created by automated daily schedule"""
    MANUAL: Backup.BackupCreationType.ValueType  # 2
    """Backup created by user request"""

    class _BackupStatus:
        ValueType = typing.NewType("ValueType", builtins.int)
        V: typing_extensions.TypeAlias = ValueType

    class _BackupStatusEnumTypeWrapper(google.protobuf.internal.enum_type_wrapper._EnumTypeWrapper[Backup._BackupStatus.ValueType], builtins.type):
        DESCRIPTOR: google.protobuf.descriptor.EnumDescriptor
        BACKUP_STATUS_UNSPECIFIED: Backup._BackupStatus.ValueType  # 0
        DONE: Backup._BackupStatus.ValueType  # 1
        """Backup is done"""
        CREATING: Backup._BackupStatus.ValueType  # 2
        """Backup is creating"""

    class BackupStatus(_BackupStatus, metaclass=_BackupStatusEnumTypeWrapper): ...
    BACKUP_STATUS_UNSPECIFIED: Backup.BackupStatus.ValueType  # 0
    DONE: Backup.BackupStatus.ValueType  # 1
    """Backup is done"""
    CREATING: Backup.BackupStatus.ValueType  # 2
    """Backup is creating"""

    ID_FIELD_NUMBER: builtins.int
    FOLDER_ID_FIELD_NUMBER: builtins.int
    CREATED_AT_FIELD_NUMBER: builtins.int
    SOURCE_CLUSTER_ID_FIELD_NUMBER: builtins.int
    STARTED_AT_FIELD_NUMBER: builtins.int
    SIZE_FIELD_NUMBER: builtins.int
    TYPE_FIELD_NUMBER: builtins.int
    METHOD_FIELD_NUMBER: builtins.int
    JOURNAL_SIZE_FIELD_NUMBER: builtins.int
    STATUS_FIELD_NUMBER: builtins.int
    id: builtins.str
    """Required. ID of the backup."""
    folder_id: builtins.str
    """ID of the folder that the backup belongs to."""
    source_cluster_id: builtins.str
    """ID of the PostgreSQL cluster that the backup was created for."""
    size: builtins.int
    """Size of backup, in bytes"""
    type: global___Backup.BackupCreationType.ValueType
    """How this backup was created (manual/automatic/etc...)"""
    method: global___Backup.BackupMethod.ValueType
    """Method of backup creation"""
    journal_size: builtins.int
    """Size of the journal associated with backup, in bytes"""
    status: global___Backup.BackupStatus.ValueType
    """Status of backup"""
    @property
    def created_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Creation timestamp in [RFC3339](https://www.ietf.org/rfc/rfc3339.txt) text format
        (i.e. when the backup operation was completed).
        """

    @property
    def started_at(self) -> google.protobuf.timestamp_pb2.Timestamp:
        """Time when the backup operation was started."""

    def __init__(
        self,
        *,
        id: builtins.str = ...,
        folder_id: builtins.str = ...,
        created_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        source_cluster_id: builtins.str = ...,
        started_at: google.protobuf.timestamp_pb2.Timestamp | None = ...,
        size: builtins.int = ...,
        type: global___Backup.BackupCreationType.ValueType = ...,
        method: global___Backup.BackupMethod.ValueType = ...,
        journal_size: builtins.int = ...,
        status: global___Backup.BackupStatus.ValueType = ...,
    ) -> None: ...
    def HasField(self, field_name: typing.Literal["created_at", b"created_at", "started_at", b"started_at"]) -> builtins.bool: ...
    def ClearField(self, field_name: typing.Literal["created_at", b"created_at", "folder_id", b"folder_id", "id", b"id", "journal_size", b"journal_size", "method", b"method", "size", b"size", "source_cluster_id", b"source_cluster_id", "started_at", b"started_at", "status", b"status", "type", b"type"]) -> None: ...

global___Backup = Backup
