"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.operation.operation_pb2
import yandex.cloud.organizationmanager.v1.saml.federation_pb2
import yandex.cloud.organizationmanager.v1.saml.federation_service_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class FederationServiceStub:
    """A set of methods for managing federations."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.GetFederationRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_pb2.Federation,
    ]
    """Returns the specified federation.

    To get the list of available federations, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsResponse,
    ]
    """Retrieves the list of federations in the specified organization."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.CreateFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a federation in the specified organization."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.UpdateFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified federation."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified federation."""

    AddUserAccounts: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.AddFederatedUserAccountsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Adds users to the specified federation."""

    DeleteUserAccounts: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederatedUserAccountsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes users from the specified federation."""

    ListUserAccounts: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsResponse,
    ]
    """Lists users for the specified federation."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsResponse,
    ]
    """Lists operations for the specified federation."""

class FederationServiceAsyncStub:
    """A set of methods for managing federations."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.GetFederationRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_pb2.Federation,
    ]
    """Returns the specified federation.

    To get the list of available federations, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsResponse,
    ]
    """Retrieves the list of federations in the specified organization."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.CreateFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a federation in the specified organization."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.UpdateFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified federation."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederationRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified federation."""

    AddUserAccounts: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.AddFederatedUserAccountsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Adds users to the specified federation."""

    DeleteUserAccounts: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederatedUserAccountsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes users from the specified federation."""

    ListUserAccounts: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsResponse,
    ]
    """Lists users for the specified federation."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsRequest,
        yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsResponse,
    ]
    """Lists operations for the specified federation."""

class FederationServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing federations."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.GetFederationRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.organizationmanager.v1.saml.federation_pb2.Federation, collections.abc.Awaitable[yandex.cloud.organizationmanager.v1.saml.federation_pb2.Federation]]:
        """Returns the specified federation.

        To get the list of available federations, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsResponse, collections.abc.Awaitable[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationsResponse]]:
        """Retrieves the list of federations in the specified organization."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.CreateFederationRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a federation in the specified organization."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.UpdateFederationRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified federation."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederationRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified federation."""

    @abc.abstractmethod
    def AddUserAccounts(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.AddFederatedUserAccountsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Adds users to the specified federation."""

    @abc.abstractmethod
    def DeleteUserAccounts(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.DeleteFederatedUserAccountsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes users from the specified federation."""

    @abc.abstractmethod
    def ListUserAccounts(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsResponse, collections.abc.Awaitable[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederatedUserAccountsResponse]]:
        """Lists users for the specified federation."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsResponse, collections.abc.Awaitable[yandex.cloud.organizationmanager.v1.saml.federation_service_pb2.ListFederationOperationsResponse]]:
        """Lists operations for the specified federation."""

def add_FederationServiceServicer_to_server(servicer: FederationServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
