"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.operation.operation_pb2
import yandex.cloud.resourcemanager.v1.cloud_pb2
import yandex.cloud.resourcemanager.v1.cloud_service_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class CloudServiceStub:
    """A set of methods for managing Cloud resources."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.GetCloudRequest,
        yandex.cloud.resourcemanager.v1.cloud_pb2.Cloud,
    ]
    """Returns the specified Cloud resource.

    To get the list of available Cloud resources, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsRequest,
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsResponse,
    ]
    """Retrieves the list of Cloud resources."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.CreateCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a cloud in the specified organization."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.UpdateCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified cloud."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.DeleteCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified cloud."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsRequest,
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsResponse,
    ]
    """Lists operations for the specified cloud."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the specified cloud.
    """

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the specified cloud."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified cloud."""

class CloudServiceAsyncStub:
    """A set of methods for managing Cloud resources."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.GetCloudRequest,
        yandex.cloud.resourcemanager.v1.cloud_pb2.Cloud,
    ]
    """Returns the specified Cloud resource.

    To get the list of available Cloud resources, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsRequest,
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsResponse,
    ]
    """Retrieves the list of Cloud resources."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.CreateCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a cloud in the specified organization."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.UpdateCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified cloud."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.DeleteCloudRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified cloud."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsRequest,
        yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsResponse,
    ]
    """Lists operations for the specified cloud."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """access

    Lists access bindings for the specified cloud.
    """

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the specified cloud."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified cloud."""

class CloudServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing Cloud resources."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.GetCloudRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.resourcemanager.v1.cloud_pb2.Cloud, collections.abc.Awaitable[yandex.cloud.resourcemanager.v1.cloud_pb2.Cloud]]:
        """Returns the specified Cloud resource.

        To get the list of available Cloud resources, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsResponse, collections.abc.Awaitable[yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudsResponse]]:
        """Retrieves the list of Cloud resources."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.CreateCloudRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a cloud in the specified organization."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.UpdateCloudRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified cloud."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.DeleteCloudRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified cloud."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsResponse, collections.abc.Awaitable[yandex.cloud.resourcemanager.v1.cloud_service_pb2.ListCloudOperationsResponse]]:
        """Lists operations for the specified cloud."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """access

        Lists access bindings for the specified cloud.
        """

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the specified cloud."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the specified cloud."""

def add_CloudServiceServicer_to_server(servicer: CloudServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
