"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.access.access_pb2
import yandex.cloud.operation.operation_pb2
import yandex.cloud.serverless.eventrouter.v1.bus_pb2
import yandex.cloud.serverless.eventrouter.v1.bus_service_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class BusServiceStub:
    """A set of methods for managing buses for serverless eventrouter."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.GetBusRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_pb2.Bus,
    ]
    """Returns the specified bus.
    To get the list of all available buses, make a [List] request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesResponse,
    ]
    """Retrieves the list of buses in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.CreateBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a bus in the specified folder."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.UpdateBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified bus."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.DeleteBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified bus."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsResponse,
    ]
    """Lists operations for the specified bus."""

    ListAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified bus."""

    SetAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the bus."""

    UpdateAccessBindings: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified bus."""

class BusServiceAsyncStub:
    """A set of methods for managing buses for serverless eventrouter."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.GetBusRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_pb2.Bus,
    ]
    """Returns the specified bus.
    To get the list of all available buses, make a [List] request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesResponse,
    ]
    """Retrieves the list of buses in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.CreateBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates a bus in the specified folder."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.UpdateBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified bus."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.DeleteBusRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified bus."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsRequest,
        yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsResponse,
    ]
    """Lists operations for the specified bus."""

    ListAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        yandex.cloud.access.access_pb2.ListAccessBindingsResponse,
    ]
    """Lists existing access bindings for the specified bus."""

    SetAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Sets access bindings for the bus."""

    UpdateAccessBindings: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates access bindings for the specified bus."""

class BusServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing buses for serverless eventrouter."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.GetBusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.serverless.eventrouter.v1.bus_pb2.Bus, collections.abc.Awaitable[yandex.cloud.serverless.eventrouter.v1.bus_pb2.Bus]]:
        """Returns the specified bus.
        To get the list of all available buses, make a [List] request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesResponse, collections.abc.Awaitable[yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusesResponse]]:
        """Retrieves the list of buses in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.CreateBusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates a bus in the specified folder."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.UpdateBusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified bus."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.DeleteBusRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified bus."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsResponse, collections.abc.Awaitable[yandex.cloud.serverless.eventrouter.v1.bus_service_pb2.ListBusOperationsResponse]]:
        """Lists operations for the specified bus."""

    @abc.abstractmethod
    def ListAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.ListAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.access.access_pb2.ListAccessBindingsResponse, collections.abc.Awaitable[yandex.cloud.access.access_pb2.ListAccessBindingsResponse]]:
        """Lists existing access bindings for the specified bus."""

    @abc.abstractmethod
    def SetAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.SetAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Sets access bindings for the bus."""

    @abc.abstractmethod
    def UpdateAccessBindings(
        self,
        request: yandex.cloud.access.access_pb2.UpdateAccessBindingsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates access bindings for the specified bus."""

def add_BusServiceServicer_to_server(servicer: BusServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
