"""
@generated by mypy-protobuf.  Do not edit manually!
isort:skip_file
"""

import abc
import collections.abc
import grpc
import grpc.aio
import typing
import yandex.cloud.operation.operation_pb2
import yandex.cloud.vpc.v1.privatelink.private_endpoint_pb2
import yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2

_T = typing.TypeVar("_T")

class _MaybeAsyncIterator(collections.abc.AsyncIterator[_T], collections.abc.Iterator[_T], metaclass=abc.ABCMeta): ...

class _ServicerContext(grpc.ServicerContext, grpc.aio.ServicerContext):  # type: ignore[misc, type-arg]
    ...

class PrivateEndpointServiceStub:
    """A set of methods for managing PrivateEndpoint resources."""

    def __init__(self, channel: typing.Union[grpc.Channel, grpc.aio.Channel]) -> None: ...
    Get: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.GetPrivateEndpointRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_pb2.PrivateEndpoint,
    ]
    """Returns the specified Private Endpoint resource.

    To get the list of all available PrivateEndpoint resources, make a [List]
    request.
    """

    List: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsResponse,
    ]
    """Retrieves the list of PrivateEndpoint resources in the specified folder."""

    Create: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.CreatePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates an private endpoint in the specified folder and network."""

    Update: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.UpdatePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified private endpoint."""

    Delete: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.DeletePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified private endpoint."""

    ListOperations: grpc.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsResponse,
    ]
    """List operations for the specified private endpoint."""

class PrivateEndpointServiceAsyncStub:
    """A set of methods for managing PrivateEndpoint resources."""

    Get: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.GetPrivateEndpointRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_pb2.PrivateEndpoint,
    ]
    """Returns the specified Private Endpoint resource.

    To get the list of all available PrivateEndpoint resources, make a [List]
    request.
    """

    List: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsResponse,
    ]
    """Retrieves the list of PrivateEndpoint resources in the specified folder."""

    Create: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.CreatePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Creates an private endpoint in the specified folder and network."""

    Update: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.UpdatePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Updates the specified private endpoint."""

    Delete: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.DeletePrivateEndpointRequest,
        yandex.cloud.operation.operation_pb2.Operation,
    ]
    """Deletes the specified private endpoint."""

    ListOperations: grpc.aio.UnaryUnaryMultiCallable[
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsRequest,
        yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsResponse,
    ]
    """List operations for the specified private endpoint."""

class PrivateEndpointServiceServicer(metaclass=abc.ABCMeta):
    """A set of methods for managing PrivateEndpoint resources."""

    @abc.abstractmethod
    def Get(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.GetPrivateEndpointRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.vpc.v1.privatelink.private_endpoint_pb2.PrivateEndpoint, collections.abc.Awaitable[yandex.cloud.vpc.v1.privatelink.private_endpoint_pb2.PrivateEndpoint]]:
        """Returns the specified Private Endpoint resource.

        To get the list of all available PrivateEndpoint resources, make a [List]
        request.
        """

    @abc.abstractmethod
    def List(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsResponse, collections.abc.Awaitable[yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointsResponse]]:
        """Retrieves the list of PrivateEndpoint resources in the specified folder."""

    @abc.abstractmethod
    def Create(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.CreatePrivateEndpointRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Creates an private endpoint in the specified folder and network."""

    @abc.abstractmethod
    def Update(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.UpdatePrivateEndpointRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Updates the specified private endpoint."""

    @abc.abstractmethod
    def Delete(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.DeletePrivateEndpointRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.operation.operation_pb2.Operation, collections.abc.Awaitable[yandex.cloud.operation.operation_pb2.Operation]]:
        """Deletes the specified private endpoint."""

    @abc.abstractmethod
    def ListOperations(
        self,
        request: yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsRequest,
        context: _ServicerContext,
    ) -> typing.Union[yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsResponse, collections.abc.Awaitable[yandex.cloud.vpc.v1.privatelink.private_endpoint_service_pb2.ListPrivateEndpointOperationsResponse]]:
        """List operations for the specified private endpoint."""

def add_PrivateEndpointServiceServicer_to_server(servicer: PrivateEndpointServiceServicer, server: typing.Union[grpc.Server, grpc.aio.Server]) -> None: ...
